moSetGetCmd = {};

function moSetGetCmd:cmdFromReady(getIconCmdTable, getCmdName, getCmdFrom, getCmdFromRealName, intern, whichCmdTable)
	if intern == nil or not intern then
		for cmdTable=1, #MultiOverlayV3.cmdTable do
			for cmd=1, #MultiOverlayV3.cmdTable[cmdTable].cmd do
				local isCmd = MultiOverlayV3.cmdTable[cmdTable].cmd[cmd];
				if isCmd ~= nil then
					if isCmd.name == getCmdName and MultiOverlayV3.cmdTable[cmdTable].luaName == getCmdFrom and MultiOverlayV3.cmdTable[cmdTable].realName == getCmdFromRealName then
						if getIconCmdTable ~= nil then
							if isCmd.click[mouseClickType] and getIconCmdTable.click[mouseClickType] then 
								return isCmd, cmdTable, cmd;
							end;
						else
							return isCmd;
						end;
					end;
				end;
			end;
		end;
	elseif intern ~= nil and intern then
		local whichSubCmdTable = whichCmdTable or MultiOverlayV3.ownCmdTable
		if MultiOverlayV3.cmdTable[whichSubCmdTable] ~= nil then
			for cmd=1, #MultiOverlayV3.cmdTable[whichSubCmdTable].cmd do
				local isCmd = MultiOverlayV3.cmdTable[whichSubCmdTable].cmd[cmd];
				if isCmd ~= nil then
					if isCmd.name == getCmdName and MultiOverlayV3.cmdTable[whichSubCmdTable].luaName == getCmdFrom and MultiOverlayV3.cmdTable[whichSubCmdTable].realName == getCmdFromRealName then
						if getIconCmdTable ~= nil then
							if isCmd.click[mouseClickType] and getIconCmdTable.click[mouseClickType] then 
								return isCmd, whichSubCmdTable, cmd;
							end;
						else
							return isCmd;
						end;
					end;
				end;
			end;
		end;
	end;
	return nil;
end;

function moSetGetCmd:setPdaCmd(whichPDA, clickAreaTable, mouseClick, mouseClickType)
	local whichSubPDA = whichPDA or "masterPDA_";
	local acceptCmdTyp = moGeneralSettings.acceptCmdTyp;
	function searchCmdTable(getIconCmdTable, getCmdName, getCmdFrom, getCmdFromRealName)
		for cmdTable=1, #MultiOverlayV3.cmdTable do
			for cmd=1, #MultiOverlayV3.cmdTable[cmdTable].cmd do
				local isCmd = MultiOverlayV3.cmdTable[cmdTable].cmd[cmd];
				if isCmd ~= nil then
					if isCmd.name == getCmdName and MultiOverlayV3.cmdTable[cmdTable].luaName == getCmdFrom and MultiOverlayV3.cmdTable[cmdTable].realName == getCmdFromRealName then
						if isCmd.click[mouseClickType] and getIconCmdTable.click[mouseClickType] then 
							return isCmd, cmdTable, cmd;
						end;
					end;
				end;
			end;
		end;
		return nil;
	end;
	if mouseClick then
		if moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].app[clickAreaTable.appIcon].cmd ~= nil and #moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].app[clickAreaTable.appIcon].cmd > 0 then
			local cmdExecuted = 0;
			for a=1, #moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].app[clickAreaTable.appIcon].cmd do
				local getIconCmdTable = moSetGetOverlays.pda[whichSubPDA].line[clickAreaTable.line].app[clickAreaTable.appIcon].cmd[a];
				if getIconCmdTable ~= nil then					
					local getCmdName = getIconCmdTable.name;
					local getCmdFrom = getIconCmdTable.from;
					local getCmdFromRealName = getIconCmdTable.fromRealName;
					local getCmdTable, cmdTablePos, cmdPos = searchCmdTable(getIconCmdTable, getCmdName, getCmdFrom, getCmdFromRealName);
					if getCmdTable ~= nil then						
						if not getCmdTable.multiple and cmdExecuted > 0 then return;end; --not multiple cmd, here stop
						if string.find(acceptCmdTyp, getCmdTable.typ) and getCmdTable.typ == "action_" then --typ action
							if type(getCmdTable.action) == "function" then
								getCmdTable.action(mouseClickType, cmdTablePos, cmdPos, clickAreaTable, getCmdTable);
								cmdExecuted = cmdExecuted+1;
							elseif type(getCmdTable.action) == "string" then
								MultiOverlayV3[MultiOverlayV3.cmdTable[cmdTablePos].luaName][getCmdTable.action](mouseClickType, cmdTablePos, cmdPos, clickAreaTable, getCmdTable);
								cmdExecuted = cmdExecuted+1;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function moSetGetCmd:generateNewCmd(...)
	if MultiOverlayV3.cmdTable == nil then MultiOverlayV3.cmdTable = {};end;
	local errorTable = {};
	local cmdTablePos = 0;
	local acceptCmdTyp = moGeneralSettings.acceptCmdTyp;
	if ... ~= nil then		
		local args = ...;		
		if args.insert == nil then
			if args.realName == nil or type(args.realName) ~= "string" or string.len(args.realName) <= 3 then errorTable[#errorTable+1] = "Your realName= too short or not found";end;
			if args.luaName == nil or type(args.luaName) ~= "string" then errorTable[#errorTable+1] = "Your luaName= type not string or not found";end;
		end;
		if args.cmdTable == nil or type(args.cmdTable) ~= "table" then errorTable[#errorTable+1] = "Your cmdTable= type not table or not found";end;
		if #errorTable == 0 then
			local cmdTable = args.cmdTable;
			if #cmdTable <= 0 then errorTable[#errorTable+1] = "Your cmdTable= not found entrys";end;
			if #errorTable == 0 then
				for a=1, #cmdTable do
					if cmdTable[a].cmdName == nil or type(cmdTable[a].cmdName) ~= "string" then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... cmdName= type not string or not found";end;
					if cmdTable[a].displayName == nil or type(cmdTable[a].displayName) ~= "string" then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... displayName= type not string or not found";end;
					if cmdTable[a].typ == nil or type(cmdTable[a].typ) ~= "string" or not string.find(acceptCmdTyp, string.lower(cmdTable[a].typ).. "_") then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... typ= type not string or not found or typ not accepts";end;
					if cmdTable[a].action == nil then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... action= not found (".. tostring(cmdTable[a].action).. ")";end;
					--if cmdTable[a].action ~= nil and (type(cmdTable[a].action) ~= "string" or "function") then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... action= type not string or function or not found";end;
					if #errorTable == 0 and type(cmdTable[a].action) == "string" and MultiOverlayV3[args.luaName][cmdTable[a].action] == nil then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... action= type string not found or incorrect ";end;
					if #errorTable == 0 and type(cmdTable[a].action) == "function" and cmdTable[a].action == nil then errorTable[#errorTable+1] = "Your cmdTable=(cmd ".. tostring(a).. " value)... action= type function not found or incorrect";end;
				end;
				if #errorTable == 0 then
					local newCmdTable = nil;					
					if args.insert ~= nil and args.insert then
						newCmdTable = MultiOverlayV3.cmdTable[args.cmdOldTable];						
					else					
						MultiOverlayV3.cmdTable[#MultiOverlayV3.cmdTable+1] = {};
						newCmdTable = MultiOverlayV3.cmdTable[#MultiOverlayV3.cmdTable];
						newCmdTable.cmd = {};
						newCmdTable.realName = args.realName or "Cmd Origin unknown";
						newCmdTable.guiMenue = args.guiMenue or nil;
						newCmdTable.guiMenueTable = args.guiMenueTable or nil;
						newCmdTable.guiMenueName = args.guiMenueName or "Gui Menue Name Unknown";
						newCmdTable.onOff = args.onOff or nil;
						newCmdTable.luaName = args.luaName or nil;
					end;										
					for tempCmd=1, #cmdTable do
						newCmdTable.cmd[#newCmdTable.cmd+1] = {};
						local cmd = #newCmdTable.cmd;
						newCmdTable.cmd[cmd].name = tostring(cmdTable[tempCmd].cmdName);
						newCmdTable.cmd[cmd].displayName = tostring(cmdTable[tempCmd].displayName);
						newCmdTable.cmd[cmd].iconSuggestion = cmdTable[tempCmd].iconSuggestion;
						newCmdTable.cmd[cmd].iconSuggestionTxt = tostring(cmdTable[tempCmd].iconSuggestionTxt);
						newCmdTable.cmd[cmd].multiple = cmdTable[tempCmd].multiple or nil;
						newCmdTable.cmd[cmd].sortBy = cmdTable[tempCmd].sortBy or "Other";
						newCmdTable.cmd[cmd].lineTyp = cmdTable[tempCmd].lineTyp or 1;
						newCmdTable.cmd[cmd].infoTxt = tostring(cmdTable[tempCmd].infoTxt);
						newCmdTable.cmd[cmd].helpTxt = tostring(cmdTable[tempCmd].helpTxt);
						newCmdTable.cmd[cmd].click = cmdTable[tempCmd].click;
						if newCmdTable.cmd[cmd].click == nil or type(newCmdTable.cmd[cmd].click) ~= "table" then newCmdTable.cmd[cmd].click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=false, key=false};errorTable[#errorTable+1] = "cmdTable=(cmd ".. tostring(tempCmd).. ") click=... not correct or be missing -was set by default click{true, false ,false, false}";end;
						--if #errorTable == 0 and type(newCmdTable.cmd[cmd].click) == "table" then
							--if #newCmdTable.cmd[cmd].click > 3 or #newCmdTable.cmd[cmd].click < 3 then newCmdTable.cmd[cmd].click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=false};errorTable[#errorTable+1] = "cmdTable=(cmd ".. tostring(cmd).. ") click=... not correct or be missing 1 entry -was set by default click{true, false ,false}"end;
							--if #errorTable == 0 then
								--if type(newCmdTable.cmd[cmd].click[1]) ~= "boolean" then newCmdTable.cmd[cmd].click[1] = true;errorTable[#errorTable+1] = "cmdTable=(cmd ".. tostring(cmd).. ") click=... entry 1 -mouse left Click was set by default click entry 1 true";end;
								--if type(newCmdTable.cmd[cmd].click[2]) ~= "booelan" then newCmdTable.cmd[cmd].click[2] = false;errorTable[#errorTable+1] = "cmdTable=(cmd ".. tostring(cmd).. ") click=... entry 2 -mouse middle Click was set by default click entry 2 false";end;
								--if type(newCmdTable.cmd[cmd].click[3]) ~= "booelan" then newCmdTable.cmd[cmd].click[3] = false;errorTable[#errorTable+1] = "cmdTable=(cmd ".. tostring(cmd).. ") click=... entry 3 -mouse right Click was set by default click entry 3 false";end;
							--end;
						--end;
						newCmdTable.cmd[cmd].typ = string.lower(cmdTable[tempCmd].typ).. "_";
						newCmdTable.cmd[cmd].action = cmdTable[tempCmd].action;
						newCmdTable.cmd[cmd].ownValues = cmdTable[tempCmd].ownValues or nil;						
					end;
					cmdTablePos = #MultiOverlayV3.cmdTable;
				end;
			end;
		end;		
	else
		errorTable[#errorTable+1] = "Not found Cmd Args Table or not a Table"
	end;
	return cmdTablePos, errorTable;
end;

function moSetGetCmd:deleteCmd(...)
	if ... ~= nil then
		local args = ...;
		if MultiOverlayV3.cmdTable[args.cmdTable] ~= nil and MultiOverlayV3.cmdTable[args.cmdTable].cmd ~= nil and #MultiOverlayV3.cmdTable[args.cmdTable].cmd > 0 then
			for cmd=1 ,#MultiOverlayV3.cmdTable[args.cmdTable].cmd do
				if MultiOverlayV3.cmdTable[args.cmdTable].cmd[cmd].name == args.cmdName and MultiOverlayV3.cmdTable[args.cmdTable].cmd[cmd].luaName == args.luaName and MultiOverlayV3.cmdTable[args.cmdTable].cmd[cmd].realName == args.realName then
					table.remove(MultiOverlayV3.cmdTable[args.cmdTable].cmd, cmd);
				end;
			end;
			moSetGetGuiMenue:refreshAllSideCmdPullDownLine();
		end;
	end;
end;

function moSetGetCmd:generateOwnCmd()
	local moCmdTable, errorTable = 0, {};
	
	--default values--
	local newCmdTable = {	
	realName = tostring(MultiOverlayV3.metadata.title);
	guiMenue = false;
	--guiMenueTable = 0;
	--guiMenueName = tostring(MultiOverlayV3.metadata.title);
	onOff = true;
	luaName = "multioverlayV3Hud"; --needs(string *your lua name*), for cmd action(is cmd action string) and classification in Save/XML --> ! should be unique !	
	cmdTable = {};	
	};
	--default values--	
	--cmd 1--
	newCmdTable.cmdTable[1] = {
		cmdName = "Empty";
		displayName = "Empty";		
		multiple = true;
		sortBy = "Moh Intern";
		infoTxt = "Empty or Delete (is Save click)";
		helpTxt = "";
		click = {mouseButtonLeft=false, mouseButtonMiddle=false, mouseButtonRight=false, key=false}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.emptyCmd; --a function
		ownValues = {};			 
	};
	--cmd 1--
	--cmd 2--
	newCmdTable.cmdTable[2] = {
		cmdName = "printCmd";
		displayName = "Print all Cmd in cmd.txt";		
		multiple = true;
		sortBy = "Moh Intern";
		infoTxt = "Speichert alle Cmd in der Datei cmd.txt ab";
		helpTxt = "Print all MultiOverlayV3 Cmd`s";
		click = {mouseButtonLeft=true, mouseButtonMiddle=false, mouseButtonRight=false, key=false}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.printCmd; --a function
		ownValues = {};			 
	};
	--cmd 2--
	--cmd 3--
	newCmdTable.cmdTable[3] = {
		cmdName = "openCloseAutoDrive";
		displayName = "AutoDrive Hud On/Off";		
		multiple = true;
		sortBy = "Moh OtherMod";
		infoTxt = "Öffnet und schliesst das AutoDrivew Hud Fenster";
		helpTxt = "Open/Close AutoDrive Hud";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.openCloseAutoDrive; --a function
		ownValues = {};			 
	};
	--cmd 3--
	--cmd 4--
	newCmdTable.cmdTable[4] = {
		cmdName = "openCloseCourseplay";
		displayName = "Courseplay Hud On/Off";		
		multiple = true;
		sortBy = "Moh OtherMod";
		infoTxt = "Öffnet und schliesst das Courseplay Hud Fenster";
		helpTxt = "Open/Close Courseplay Hud";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.openCloseCourseplay; --a function
		ownValues = {};			 
	};
	--cmd 4--
	--cmd 5--
	newCmdTable.cmdTable[5] = {
		cmdName = "openCloseGlobalCompany";
		displayName = "GlobalCompany Main On/Off";		
		multiple = true;
		sortBy = "Moh OtherMod";
		infoTxt = "Öffnet und schliesst das GlobalCompany Main Fenster";
		helpTxt = "Open/Close GlobalCompany Main";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.openCloseGlobalCompanyMain; --a function
		ownValues = {};			 
	};
	--cmd 5--
	--cmd 6--
	newCmdTable.cmdTable[6] = {
		cmdName = "closeAllPdas";
		displayName = "Close all PDAs";		
		multiple = true;
		sortBy = "Moh PDAs";
		infoTxt = "Schliesst alle PDA Fenster";
		helpTxt = "Close all PDAs";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.closeAllPdas; --a function
		ownValues = {};			 
	};
	--cmd 6--
	--cmd 7--
	newCmdTable.cmdTable[7] = {
		cmdName = "closeAllSlots";
		displayName = "Close all SLOTs";		
		multiple = true;
		sortBy = "Moh SLOTs";
		infoTxt = "Schliesst alle Slot Fenster";
		helpTxt = "Close all SLOTs";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true}; --left/middle/right MouseClick
		typ = "action";
		action = moCmd.closeAllSlots; --a function
		ownValues = {};			 
	};
	--cmd 7--
	moCmdTable, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	if moCmdTable ~= 0 then MultiOverlayV3.ownCmdTable = moCmdTable;end;	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
	--default values--	
end;

function moSetGetCmd:generatePdaOpenCloseCmd(whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.ownCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "openClosePda_".. tostring(whichSubPDA);
		displayName = "Open/Close PDA ".. tostring(moSetGetOverlays.pda[whichSubPDA].name);		
		multiple = true;
		sortBy = "Moh PDAs";
		infoTxt = "Öffnet/Schliesst das Tablet PDA ".. tostring(moSetGetOverlays.pda[whichSubPDA].name);
		helpTxt = "Open/Close PDA";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		typ = "action";
		action = moCmd.openClosePda; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate Open/Close Pda error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;		
end;

function moSetGetCmd:generateSlotOpenCloseCmd(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.ownCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "openCloseSlot_".. tostring(whichSubSLOT);
		displayName = "Open/Close Slot ".. tostring(moSetGetOverlays.slot[whichSubSLOT].name);		
		multiple = true;
		sortBy = "Moh SLOTs";
		infoTxt = "Öffnet/Schliesst den Slot ".. tostring(moSetGetOverlays.slot[whichSubSLOT].name);
		helpTxt = "Open/Close SLOT";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		typ = "action";
		action = moCmd.openCloseSlot; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate Open/Close Slot error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;		
end;