fillTypesAmount = {};

--needs module fillTypes,amount,storages,greatDemand
--lineType 2/fillType and amount
function fillTypesAmount:load()
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then fillTypesAmount.output = {};return;end;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};	
	for a=1, #moFillTypes.values.fillTypes do
		if moFillTypes.values.fillTypes[a] ~= nil and moFillTypes.values.fillTypes[a].view then
			local fillTypes = moFillTypes.values.fillTypes[a];
			lineTable[#lineTable+1] = {};
			local isLineTable = lineTable[#lineTable];				
			isLineTable.txt = {};			
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 70;	--width prozent		
			isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);
			local isGreatDemand = moFillTypes.values.greatDemand[fillTypes.index] ~= nil and moFillTypes.values.greatDemand[fillTypes.index].isRunning and moFillTypes.values.greatDemand[fillTypes.index].isValid;
			isLineTable.txt[1].bold = moFillTypes.values.txtBold;
			--isLineTable.txt[1].difSize = 0.001;							
			local name = "";
			if moFillTypes.values.name then name = fillTypes.name;end;
			if moFillTypes.values.regName then
				if string.len(name) == 0 then name = fillTypes.regName;else name = name.. " (".. fillTypes.regName.. ")";end;
			end;
			if moFillTypes.values.index then
				if string.len(name) == 0 then name = fillTypes.index;else name = name.. " *".. fillTypes.index.. "*";end;
			end;
			isLineTable.txt[1].txt = tostring(name);
			----------------------------------------
			isLineTable.txt[2] = {};
			isLineTable.txt[2].width = 30;	--width prozent			
			local amount = moFillTypes.values.amount[fillTypes.index];
			local isUpAlpha = true;			
			if amount ~= nil and type(amount) == "number" and amount <=0.1 then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtNoAmountColor);isUpAlpha=false;end;
			if amount == nil then amount = 0;isLineTable.txt[1].color = moColors:getColor(moModule.values.txtNoAmountColor);isUpAlpha=false;end;
			if isGreatDemand then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtGreatDemandColor);end;
			isLineTable.txt[2].color = moColors:getColor(moModule.values.txtNoAmountColor);
			if isUpAlpha then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);isLineTable.txt[2].color = moColors:getColor(moModule.values.txtAmountColor);end;			
			isLineTable.txt[2].amount = Utils.getNoNil(amount, 0);
			isLineTable.txt[2].txt = string.format("%1.0f", "".. tostring(amount)); --g_i18n:formatNumber(foodGroupTable.fillLevel);
			isLineTable.txt[2].bold = moModule.values.txtBold;
			--isLineTable.txt[2].difSize = 0.001;
			isLineTable.amount = Utils.getNoNil(amount, 0);
		end;
	end;
	function comp(w1,w2)		
		if w1.amount > w2.amount then
			return true;
		end;				
	end;
	table.sort(lineTable, comp);	
	fillTypesAmount.output = lineTable;
end;

function fillTypesAmount.giveOutputTable()	
	moModule.active.fillTypes.isRunning = true;moModule.active.fillTypes.last = moModule.time.min+moModule.time.delay;
	moModule.active.greatDemand.isRunning = true;moModule.active.greatDemand.last = moModule.time.min+moModule.time.delay;
	moModule.active.storages.isRunning = true;moModule.active.storages.last = moModule.time.min+moModule.time.delay;
	moModule.active.amount.isRunning = true;moModule.active.amount.last = moModule.time.min+moModule.time.delay;
	fillTypesAmount:load();
	return fillTypesAmount.output;	
end;

function fillTypesAmount:reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	fillTypesAmount:load();
end;

function fillTypesAmount:generateCmd()
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "fillTypesAmount";
		displayName = "FillTypes/Amount";		
		multiple = true;
		sortBy = "Module by Moh";
		infoTxt = "Zeigt die FillTypes mit der Füllmenge an";
		helpTxt = "FillTypes and Amount in List";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		lineTyp = 2;
		typ = "output";
		action = fillTypesAmount.giveOutputTable; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate fillTypesAmount Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
end;